
#ifndef GLLISTE
#define GLLISTE

#include "winlinux.h"

#include <string.h>
//#include <iostream>

typedef struct stmemliste
    {
	int hwnd;
	long instance;
    } MEMLISTE, *LPMEMLISTE;

class GLListe  
{

private:
  // Constructeur/destructeur en private car
  GLListe (); // Seule la classe pourra créer une instance de GLListe

  ~GLListe (); // Pour éviter les destruction par erreur

public:
  // Interface publique
	void AjouteListe(int hwnd, long instance);
	void RetireListe(int hwnd);
	long ChercheListe (int hwnd);
	void ViderListe ();
	long NbElements();
	bool LireElement (int hwnd, long &instance);

  // Fonctions de création et destruction du singleton
  static GLListe *getInstance ()
  {
    if (NULL == _singleton)
    {
//        std::cout << "Création singleton Liste." << std::endl;
        _singleton =  new GLListe;
    }
/*    else
    {
        std::cout << "Singleton Liste déjà créé !" << std::endl;
    }
*/
    return _singleton;
  }

  static void kill ()
  {
    if (NULL != _singleton)
    {
        delete _singleton;
        _singleton = NULL;
    }
  }

private:
  // Variables membres
  
  int GLListeNbElem; // Nombre d'élément dans la liste
  LPMEMLISTE GLMemListe; // Pointeur sur la liste des éléments
  static GLListe *_singleton; // Pointeur sur notre instance unique de GLListe
};

#endif