// glQuaternion.h
//
//////////////////////////////////////////////////////////////////////
#if !defined(GLQUATERNION)
#define GLQUATERNION

#include "winlinux.h"
#include <math.h>

class glQuaternion  
{
public:
	glQuaternion();
	glQuaternion(GLfloat a, GLfloat b, GLfloat c, GLfloat d);
	virtual ~glQuaternion();
	// Convertion d'un axe et d'un angle en quaternion
	void convertAxeAngleDegToQuaternion(GLfloat x, GLfloat y, GLfloat z, GLfloat deg); // Angle en degres
	void convertAxeAngleRadToQuaternion(GLfloat x, GLfloat y, GLfloat z, GLfloat rad); // Angle en radian
	//Converstion d'un quaternion en axe/angle
	void convertQuaternionToAxeAngleDeg(GLfloat *x, GLfloat *y, GLfloat *z, GLfloat *angle);
	// Traduire un quaternion en matrice
	void convQuaternionMatrice(GLfloat *pMatrix);
	void normal(void);
	glQuaternion operator *(glQuaternion q); // M�thode pour permettre la miltiplication de quaternions

private:
	GLfloat a;
	GLfloat b;
	GLfloat c;
	GLfloat d;
};

#endif
