// GLTextOut.cpp
//
//////////////////////////////////////////////////////////////////////

#include "gltextout.h"
#include <math.h>
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
GLTextOut::GLTextOut()
{
	fonteOpenGL = NULL;
}

void GLTextOut::GLSetHDC (HDC hDC)
{
	hDCText = hDC;
}

void GLTextOut::GLsetInfoText (int ihauteur)
{
  hauteur = ihauteur;
}

void GLTextOut::GLgetInfoText (int* ihauteur)
{
  *ihauteur = hauteur;
}

#ifndef _WIN32
void GLTextOut::GLLoadFont(HDC hDC, char *cFontName, int iWidth, int iHeight, int iEpaisseur, int iItalic)
{
#ifndef USEGLUT
   char cNom[500];
   char cTaille[30];
   char **fontlist; // Pointeur sur un tableau de pointeurs qui contiendront les noms des fontes
   XFontStruct *info_return; // Liste des informations sur les fontes
   int listcount; // Nombre de fontes effectivement chargées
   int i; // Compteur...
    XFontStruct *font; /* Nos infos sur la fonte */
    int iNumFont = -1;
    int iDiffTrv;
    
    // Espace pour 256 caractères
    fonteOpenGL = glGenLists( 256 );

    // Connexion au serveur XWindow
    dpy = XOpenDisplay( NULL );
    
    // Génération d'un nom pour la recherche d'une fonteOpenGL
    strcpy (cNom, "*-");
    strcat (cNom, cFontName);
    strcat (cNom, "-");
    
    if (iEpaisseur < 500)
	strcat (cNom, "medium");
    else
	strcat (cNom, "medium" /*"bold"*/);
    strcat (cNom, "-");
    
    if (iItalic)
	strcat (cNom, "i");
    else
	strcat (cNom, "r");
    
    strcat (cNom, "-*-*");
      
    fontlist = XListFontsWithInfo (dpy, cNom, 100, &listcount, &info_return);
    
    printf ("Nombre de fontes trouvées: %d\n", listcount);
    
    // Nous allons maintenant rechercher la fonte la plus proche en hauteur de la valeur de iHeight
    if (fontlist != NULL && listcount > 0)
    {
	for (i=0; i< listcount;i++)
	{
	    // printf ("Font n°%d = %s, taille:%d\n", i, fontlist[i], info_return[i].max_bounds.ascent + info_return[i].min_bounds.descent);
	    if (iNumFont == -1 || fabs (iHeight - info_return[i].max_bounds.ascent - info_return[i].min_bounds.descent) <= iDiffTrv)
	    {
		iDiffTrv = fabs (iHeight - info_return[i].max_bounds.ascent - info_return[i].min_bounds.descent);
		iNumFont = i;
	    }
	}
    }
    else
	printf ("Problème lors de la récupération des noms\n");
  
    if (fontlist != NULL)
    {
        printf ("\nFonte sélectionnée n°%d pour une hauteur de %d: %s\n\n", iNumFont, info_return[iNumFont].max_bounds.ascent + info_return[iNumFont].min_bounds.descent, fontlist[iNumFont]);
	strcpy (cNom, fontlist[iNumFont]);
	GLsetInfoText (info_return[iNumFont].max_bounds.ascent + info_return[iNumFont].min_bounds.descent);
	XFreeFontInfo (fontlist, info_return, listcount);
    }
    
    printf ("Chargement d'une fonte:%s\n", cNom);
    
    // Chargement de la fonte
    font = XLoadQueryFont( dpy, cNom /*"*-helvetica-medium-r-normal--18-*-*-*-p-*-iso8859-1"*/ );

    // Si fonte absente
    if ( font == NULL )
    {
	  // On tente avec une par défaut
	    printf("Problème pour trouver une fonte X nommee :%s\n", cNom );
            font = XLoadQueryFont( dpy, "*fixed*" );
            // Là, cela devient grave, il faut arrêter !
            if ( font == NULL )
                {
                    printf("Problème pour charger une quelconque fonte X !\n" );
                }
    }

    // generation de la liste
    if (font)
    {
      glXUseXFont( font->fid, 0, 255, fonteOpenGL );

    // On libere la fonte de la mémoire, elle ne servira plus.
    XFreeFont( dpy, font );
    }
    XCloseDisplay(dpy);
#endif
    return;
}
#else
void GLTextOut::GLLoadFont(HDC hDC, char *cFontName, int iWidth, int iHeight, int iEpaisseur, int iItalic)
{
#ifndef USEGLUT
		HFONT	font	= NULL;
		HDC hDCTextCourant = NULL;

		fonteOpenGL = NULL;

		if (hDC)
			hDCTextCourant = hDC;
		else
			hDCTextCourant = hDCText;

		if (hDCTextCourant)
		{
			font = CreateFont(	iHeight * 2,					
							iWidth * 2,					
							0,					
							0,					
							iEpaisseur,				
							iItalic,				
							FALSE,				
							FALSE,				
							ANSI_CHARSET,				
							OUT_TT_PRECIS,				
							CLIP_DEFAULT_PRECIS,			
							ANTIALIASED_QUALITY,			
							FF_DONTCARE|DEFAULT_PITCH,		
							cFontName);				
			if (font)
			{
				SelectObject(hDCTextCourant, font);

				fonteOpenGL = glGenLists(256);				// Tableau sur les diff�rents caract�res
				wglUseFontBitmaps(hDCTextCourant, 0, 256, fonteOpenGL);// Chargement du tableau

				DeleteObject(font); // La fonte ne nous servira plus maintenant
			}
		}
#endif
}
#endif

void GLTextOut::GLPosText(GLfloat x, GLfloat y)
{
	glRasterPos2f(x, y);
}

GLTextOut::GLTextOut(HDC hDC)
{
  #ifdef _WIN32
	GLLoadFont(hDC, "Courier New", 0, 7, GLW_MEDIUM, FALSE);
  #else
  	GLLoadFont(hDC, "courier", 0, 7, GLW_MEDIUM, FALSE);
  #endif
}

GLTextOut::GLTextOut(HDC hDC, char* cFontName, int iWidth, int iHeight, int iEpaisseur, int iItalic)
{
	GLLoadFont(hDC, cFontName, iWidth, iHeight, iEpaisseur, iItalic);
}

GLTextOut::~GLTextOut()
{
	if (fonteOpenGL)					// Si la fonte est creee, on peut supprimer tous les caract�res
		glDeleteLists(fonteOpenGL, 256);
	fonteOpenGL = NULL;
}

bool GLTextOut::GLTextPrint (const char *fmt,...)
{
	char		text[256];		// 256 caract�res
	va_list		ap;			// Typedef Pour pointer sur la liste des arguments

	if (fmt == NULL)			// Il faut du texte...pour l'afficher
		if (fonteOpenGL)		// Il faut aussi avoir une fonte de charg�e
			return true;		// Si fonte pr�sente, on retourn vrai pour dire que le texte est affich�
		else
			return false;		// Sinon, on signale qu'il y a un pb. sur la fonte

	va_start(ap, fmt);			// Parses la cha�ne de caract�res pour r�cup�rer les variables dans le format indiqu�
	vsprintf(text, fmt, ap);			
	va_end(ap);				// text recevant le r�sultat final

	#ifndef USEGLUT
	if (fonteOpenGL)
	{
		glPushAttrib(GL_LIST_BIT);	// Push la Display List Bits
		glListBase(fonteOpenGL);	// Puis on demande l'utilisation de notre fonte
		glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Affichage du texte
		glPopAttrib();			// Pops la Display List Bits
		return true;
	}
	else
		return false;
	#else
		for (int i=0; i<strlen(text); i++)
		{
		//	MessageBox (NULL, text, "Titre", MB_OK);
			glutBitmapCharacter ( GLUT_BITMAP_8_BY_13, text[i] );
		}
	#endif
}

