#if !defined(GLTEXTOUT)
#define GLTEXTOUT

#include "winlinux.h"

#include <stdio.h>
#include <GL/gl.h>

#ifndef _WIN32
#include <GL/glx.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdarg.h>
#include <string.h>

#define FW_DONTCARE 0
#define FW_THIN 100
#define FW_EXTRALIGHT 200
#define FW_ULTRALIGHT 200
#define FW_LIGHT 300
#define FW_NORMAL 400
#define FW_REGULAR 400
#define FW_MEDIUM 500
#define FW_SEMIBOLD 600
#define FW_DEMIBOLD 600
#define FW_BOLD 700
#define FW_EXTRABOLD 800
#define FW_ULTRABOLD 800
#define FW_HEAVY 900
#define FW_BLACK 900

#endif

#define GLW_BOLD FW_BOLD
#define GLW_MEDIUM FW_MEDIUM

#ifndef _WIN32
#endif

class GLTextOut  
{

protected:
	unsigned int		fonteOpenGL;	// opengl font
	GLTextOut *GLText;
	HDC hDCText;
	int hauteur;
	#ifndef _WIN32
	Display *dpy;
	#endif
public:
	GLTextOut();
	GLTextOut(HDC hDC);
	GLTextOut(HDC hDC, char *cFontName, int iWidth, int iHeight, int iEpaisseur, int iItalic);
	// Epaisseur de 0 à 1000 (voir MS windows: , sous XWindow : 0 à 500 medium, 700 à 1000 bold (400 pour normal, 500 pour medium, 700 pour bold sous Microsoft voir fw_) 
	// Pas de controle sur la valeur si > 1000
	void GLLoadFont(HDC hDC, char *cFontName, int iWidth, int iHeight, int iEpaisseur, int iItalic);
	void GLSetHDC (HDC hDC);
	~GLTextOut();
	bool GLTextPrint (const char *fmt,...); // M�thode obsol�te utilisant le formatage de texte du C (voir printf)
	void GLPosText (GLfloat x, GLfloat y);
	void GLgetInfoText (int* hauteur);
	void GLsetInfoText (int hauteur);
};
#endif
