#include "spheroide.h"

spheroide::spheroide (float alpha, float rouge, float vert, float bleu, float rayonX, float rayonY, float rayonZ, float pas, int pasCarX, int pasCarY)
{
	// Initiliser les pas
	definirPas (pas, pasCarX, pasCarY);

	// Initialiser les rayons
	definirRayons (rayonX, rayonY, rayonZ);

	// Dfinition des couleurs
	couleurF (alpha, rouge, vert, bleu);
}

void spheroide::genere (int mode)
{
	if (uiDispLst != GL_INVALID_VALUE && uiDispLst != GL_INVALID_OPERATION && glIsList(uiDispLst))
	{
		glNewList(uiDispLst, GL_COMPILE);

		switch (mode)
		{
			case SPH_POINTS:
				Point(); // Sphere par point
				gereCouleur(true);
				break;

			case SPH_MAILLES:
				Maille0 ();
				gereCouleur(true);
				break;

			case SPH_MAILLEHV:
				Maille1 ();
				gereCouleur(true);
				break;

			case SPH_PLEIN:
				plein ();
				gereCouleur(true);
				break;
		}

		glEndList();
	}
}

void spheroide::Point (void)
{
	float sina;

	glBindTexture( GL_TEXTURE_2D, 0);

	glBegin(GL_POINTS);

	for (a=0.0f; a <= PI; a+=pas)
	{
		z = rz*cosf(a);
		sina = sinf (a);
		for (b=-PI; b <= PI; b+=pas)
		{			
			  	  
			x =rx*sina * cosf(b);
		  
			y =ry*sina * sinf(b);
	  
			normal(x, y, z);
			glVertex3f(x,y,z) ;

		}
	}
	glEnd();
}

void spheroide::Maille0 (void)
{
	// Mailles en serpent d'un sommet  l'autre de la sphre
	float sina, sinap;

	glBindTexture( GL_TEXTURE_2D, 0);

	glBegin(GL_LINES); 

	for (a=0.0f; a <= PI; a+=pas)
	{
		z = rz*cosf(a);
		z1 = rz*cosf(a + pas);

		sina = sinf (a);
		sinap = sinf (a + pas);
		for (b=-PI; b <= PI; b+=pas)
		{			

			// Mailles dans un sens
			x =rx*sina * cosf(b);
		  
			y =ry*sina * sinf(b);

			normal(x, y, z);
			glVertex3f(x,y,z) ;


			x1 =rx*sinap * cosf(b + pas);
		  
			y1 =ry*sinap * sinf(b + pas);
	  
			glVertex3f(x1,y1,z1) ;

			// Mailles dans l'autre sens
			x =rx*sinap * cosf(b);
		  
			y =ry*sinap * sinf(b);
	  
			glVertex3f(x,y,z1) ;


			x1 =rx*sina * cosf(b + pas);
		  
			y1 =ry*sina * sinf(b + pas);
	  
			glVertex3f(x1,y1,z) ;
		}

	}
	glEnd();
}

void spheroide::Maille1 (void)
{
	// Mailles Verticale et horizontale
	float sina, sinap, cosb, cosbp, sinb, sinbp;

	int iCpt1, iCpt;

	BOOL bDessineV, bDessineH;

	glBindTexture( GL_TEXTURE_2D, 0);

	glBegin(GL_LINES); 

	iCpt = pasCarreX;
	iCpt1 = pasCarreY;
	for (a=0.f; a <= PI; a+=pas)
	{

			z = rz*cosf(a);
			z1 = rz*cosf(a + pas);

			sina = sinf (a);
			sinap = sinf (a + pas);
			
			if (iCpt++ >= pasCarreX)
			{
				bDessineH = true;
				iCpt = 0;
			}
			else
				bDessineH = false;

			iCpt1 = pasCarreY;

			for (b=-PI; b <= PI; b+=pas)
			{		
				if (iCpt1++ >= pasCarreY)
				{
					bDessineV = true;
					iCpt1 = 0;
				}
				else
					bDessineV = false;

				cosb = cosf(b);
				cosbp = cosf(b + pas);
				sinb = sinf(b);
				sinbp = sinf(b + pas);

				x =rx*sina * cosb;
				y =ry*sina * sinb;

				if (b + pas >=PI) // Fin de la boucle, on va tracer un trait entre les derniers points calculs et les tous premiers points tracs
				{

					if (bDessineV) // Les verticales
					{
						normal(x, y, z);
						glVertex3f(x,y,z) ;

						x1 =rx*sinap * cosb;		  

						y1 =ry*sinap * sinb;

						glVertex3f(x1,y1,z1) ;
					}

					
					if (bDessineH) // Les horizontales
					{
						
						// X et Y reste inchang !
						normal(x, y, z);
						glVertex3f(x,y,z) ;


						x2 =rx*sina * cosf (-PI);		  

						y2 =ry*sina * sinf (-PI);

						glVertex3f(x2,y2,z) ;
					}
			  }
			  else
			  {

  					if (bDessineV) // Les verticales
					{

						normal(x, y, z);
						glVertex3f(x,y,z);


						x1 =rx*sinap * cosb;		  

						y1 =ry*sinap * sinb;

						glVertex3f(x1,y1,z1);
					}

					if (bDessineH) // Les horizontales
					{	
						x2 =rx*sina * cosbp;		  

						y2 =ry*sina * sinbp;
						// X et Y reste inchang !
						normal(x, y, z);

						glVertex3f(x,y,z);

						glVertex3f(x2,y2,z);
					}
			  }
		}

	}
	glEnd();
}

void spheroide::tracePlein (void)
{
	  glBindTexture( GL_TEXTURE_2D, 0);
      
	  glBegin(GL_QUADS);

	  for (a =0.f; a <= PI; a+=pas)
	  {
		  z = rz*cosf(a);
		  z1 = rz*cosf(a + pas);
		  z2=z;

		  for (b=-PI; b <= PI; b+=pas)
		  {
			  x = rx*sinf (a) * cosf(b);			  
			  y = ry*sinf (a) * sinf(b);

			  x1 = rx*sinf (a + pas) * cosf(b);
			  y1 = ry*sinf (a + pas) * sinf(b);

			  normal(x, y, z);
			  glVertex3f(x,y,z);

			  if (b + pas >= PI) // Fin de la boucle, on va tracer un trait entre les derniers points calculs et les tous premiers points tracs
			  {
				  glVertex3f(x1,y1,z1) ;

				  x = rx*sinf (a+ pas) * cosf(-PI);
			  
				  y = ry*sinf (a+ pas) * sinf(-PI);	  
				  glVertex3f(x,y,z1) ;

 				  x2 = rx*sinf (a) * cosf(-PI);		  

				  y2 = ry*sinf (a) * sinf(-PI);
				  glVertex3f(x2,y2,z2) ;
			  }
			  else
			  {			
				  glVertex3f(x1,y1,z1);

				  x = rx*sinf (a + pas) * cosf(b + pas);
			  
				  y = ry*sinf (a + pas) * sinf(b + pas);
				  glVertex3f(x,y,z1) ;

 				  x2 =rx*sinf (a) * cosf(b + pas);		  

				  y2 =rx*sinf (a) * sinf(b + pas);
				  glVertex3f(x2,y2,z2) ;
			  }
		  }	  
	}
	glEnd ();
}

void spheroide::traceTexture (void)
{
	float pasXTex;
	float pasYTex;
	float x1Tex, y1Tex, x2Tex, y2Tex;

	  pasYTex = 1/(PI/pas);
	  pasXTex = 1/((PI+PI)/pas);

	  glBindTexture( GL_TEXTURE_2D, idTexture);
      
	  glBegin(GL_QUADS);

	  y1Tex = 0;
	  y2Tex = pasYTex;

	  for (a =0.f; a <= PI; a+=pas)
	  {
		  z = rz*cosf(a);
		  z1 = rz*cosf(a + pas);
		  z2=z;

		  
		  x1Tex = 1;	  
		  x2Tex = 1-pasXTex;

		  for (b=-PI; b <= PI; b+=pas)
		  {
			  x = rx*sinf (a) * cosf(b);			  
			  y = ry*sinf (a) * sinf(b);

			  x1 = rx*sinf (a + pas) * cosf(b);
			  y1 = ry*sinf (a + pas) * sinf(b);

			  normal(x, y, z);
			  glTexCoord2f(x1Tex,y1Tex);glVertex3f(x,y,z);

			  if (b + pas >= PI) // Fin de la boucle, on va tracer un trait entre les derniers points calculs et les tous premiers points tracs
			  {
				  glTexCoord2f(x1Tex,y2Tex);glVertex3f(x1,y1,z1) ;

				  x = rx*sinf (a+ pas) * cosf(-PI);
			  
				  y = ry*sinf (a+ pas) * sinf(-PI);	  
				  glTexCoord2f(x2Tex,y2Tex);glVertex3f(x,y,z1) ;

 				  x2 = rx*sinf (a) * cosf(-PI);		  

				  y2 = ry*sinf (a) * sinf(-PI);
				  glTexCoord2f(x2Tex,y1Tex);glVertex3f(x2,y2,z2) ;
			  }
			  else
			  {			
				  glTexCoord2f(x1Tex,y2Tex);glVertex3f(x1,y1,z1);

				  x = rx*sinf (a + pas) * cosf(b + pas);
			  
				  y = ry*sinf (a + pas) * sinf(b + pas);
				  glTexCoord2f(x2Tex,y2Tex);glVertex3f(x,y,z1) ;

 				  x2 =rx*sinf (a) * cosf(b + pas);		  

				  y2 =rx*sinf (a) * sinf(b + pas);
				  glTexCoord2f(x2Tex,y1Tex);glVertex3f(x2,y2,z2) ;
			  }
			  x1Tex-=pasXTex;
			  x2Tex-=pasXTex;
		  }	  
		  y1Tex+=pasYTex;
		  y2Tex+=pasYTex;
	}
	glEnd ();
}

void spheroide::plein (void)
{

      if (lpcTexture != 0)
		traceTexture();
	  else
		tracePlein ();
}
