#include "defaut.h"

#ifndef _WINLINUX
  #define _WINLINUX

  #ifdef _WIN32
	  #ifndef WIN32
		  #define WIN32
	  #endif
	  
	  #include <windows.h>
	  
	  #if _MSC_VER > 1000
		  #pragma once
	  #endif // _MSC_VER > 1000
  #else
	  #pragma once
	  #if !defined (BOOL)
	    typedef unsigned char BOOL;
	  #endif
	    
	  #if !defined (TRUE)
	    #define	TRUE true
	    #define	FALSE false
	  #endif

	  // Rendre compatible la fonction retournant le handle du device Opengl et celui du rendu OpenGL entre Windows et XWindow
	  // Ce qui rendra utilisable les méthodes:
	  // HDC getDCGLW(void);
	  // HGLRC getRCGLW(void);
	  // Device context
	  #define HDC Window
	  #define HGLRC GLXContext
	  #define UINT unsigned int
	  #define HWND Window
	  #define WPARAM unsigned int
	  #define CW_DEFAULT -1
  typedef	struct stpoint
	  {
	      int x;
	      int y;
	  } POINT, *LPPOINT;
  #endif

  #ifdef USEGLUT
  // Glut est utilise
    #if USEGLUT == 1
	  #include <GL/glut.h>
    #else
	  #include INCLUDEUSEGLUT 	// INCLUDEUSEGLUT doit contenir le chemin de l'include soit <GL/glut.h> <gl\glut.h> ou "glut.h" par exemple
    #endif
    #define HWNDGLUT int // Identifiant de la fenêtre glut
  #else
    #ifdef WIN32
    // On est sous Windows sans GLUT
      #define Display int
    #else
    // On est sous X Window sans GLUT
      #define XWINDOW
      #include <X11/Xlib.h>
      #define LPARAM long
      #ifdef ARB3
	#define GLX_CONTEXT_MAJOR_VERSION_ARB       0x2091
	#define GLX_CONTEXT_MINOR_VERSION_ARB       0x2092
	typedef GLXContext (*glXCreateContextAttribsARBProc)(Display*, GLXFBConfig, GLXContext, Bool, const int*);
      #endif
    #endif
  #endif

  #include "keycompatible.h"

#define GLWPARAM WPARAM

  #include <GL/gl.h>	// OpenGL32
  #include <GL/glu.h>	// GLu32

  #ifndef PI
    #define PI			3.1415926f
  #endif

  #ifdef INCLUDE_GL_WINDOWS_PERSO
    #include INCLUDE_GL_WINDOWS_PERSO
  #endif
#endif // if non define _winlinux
